<template>
  <div :data-qa="dataQa"
       class="ob-order-route-multicard"
  >
    <div class="card-list">
      <div v-for="item in value.items"
           :key="item.uuid"
           class="card-list-item"
           :class="{ done: item.done, current: item.current, 'history-log': item.type == 'log', location: item.type == 'location', state: item.type == 'state' }"
      >
        <div class="card-list-container"
        >
          <div class="location-address">
            <div class="location-head">
              <span v-if=" item.icon === 'pin' "
                    class="icon pin"/>
              <span v-else-if=" item.icon ==='train'"
                    class="icon">
                <svg width="23"
                     height="18"
                     viewBox="0 0 23 18"
                     fill="none"
                     xmlns="http://www.w3.org/2000/svg">
                  <path fill-rule="evenodd"
                        clip-rule="evenodd"
                        d="M15 0C14.4477 0 14 0.447715 14 1V3C14 3.55228 14.4477 4 15 4V6H11V3C11.5523 3 12 2.55228 12 2C12 1.44772 11.5523 1 11 1H1C0.447715 1 0 1.44772 0 2C0 2.55228 0.447715 3 1 3L1 11.6713C1.04491 11.6158 1.09111 11.5614 1.13855 11.5082C1.96275 10.5828 3.16332 10 4.5 10C6.06021 10 7.43496 10.794 8.24223 12H17.5C18.5 12 19.0991 12.3858 19.0991 12.3858C20.0867 12.894 20.8012 13.8581 20.9646 15H23L20 10H19V7C19 6.44772 18.5523 6 18 6H17V4C17.5523 4 18 3.55228 18 3V1C18 0.447715 17.5523 0 17 0H15ZM15.5 2.5H16.5V1.5H15.5V2.5ZM4.5 10H3V8H17V10H4.5ZM6 6H2.5V3H6V6ZM9.5 6H7.5V3H9.5V6Z"
                        fill="#004BC8"/>
                  <path fill-rule="evenodd"
                        clip-rule="evenodd"
                        d="M8 14.5C8 16.433 6.433 18 4.5 18C2.567 18 1 16.433 1 14.5C1 12.567 2.567 11 4.5 11C6.433 11 8 12.567 8 14.5ZM6 14.5C6 15.3284 5.32843 16 4.5 16C3.67157 16 3 15.3284 3 14.5C3 13.6716 3.67157 13 4.5 13C5.32843 13 6 13.6716 6 14.5Z"
                        fill="#004BC8"/>
                  <path fill-rule="evenodd"
                        clip-rule="evenodd"
                        d="M14 15.5C14 16.8807 12.8807 18 11.5 18C10.1193 18 9 16.8807 9 15.5C9 14.1193 10.1193 13 11.5 13C12.8807 13 14 14.1193 14 15.5ZM12 15.5C12 15.7761 11.7761 16 11.5 16C11.2239 16 11 15.7761 11 15.5C11 15.2239 11.2239 15 11.5 15C11.7761 15 12 15.2239 12 15.5Z"
                        fill="#004BC8"/>
                  <path fill-rule="evenodd"
                        clip-rule="evenodd"
                        d="M17.5 18C18.8807 18 20 16.8807 20 15.5C20 14.1193 18.8807 13 17.5 13C16.1193 13 15 14.1193 15 15.5C15 16.8807 16.1193 18 17.5 18ZM17.5 16C17.7761 16 18 15.7761 18 15.5C18 15.2239 17.7761 15 17.5 15C17.2239 15 17 15.2239 17 15.5C17 15.7761 17.2239 16 17.5 16Z"
                        fill="#004BC8"/>
                </svg>
              </span>
              <div class="location-head__title">
                {{ item.pointName }}
              </div>
            </div>
            <div class="location-text">
              {{ item.pointAddress }}
            </div>
          </div>
          <div class="mapper-wrapper"
               :style="{
                  left: value.items.length === item.position + 1 ? 340 + (item.position - 1) * 100 + 'px' : 340 + item.position * 100 + 'px'
               }">
            <div class="dashed-line"
                 :class="{none:item.point === 'to'}">
              <div class="dop-radio-mapper">
                <i class="icon sort"></i>
              </div>
            </div>
            <div v-if="item.topIcon === 'trailer'"
                 class="top-icon">
              <i class="icon tractor-semi-trailer-izoterm-b"></i>
            </div>
            <div v-else-if="item.topIcon === 'van'"
                 class="top-icon">
              <i class="icon railway-carriage-refrigerator"></i>
            </div>
            <div v-if="item.point == 'from'"
                 class="radio-mapper from">
              <i class="icon route-loading"/>
            </div>
            <div v-else-if="item.point == 'to'"
                 class="radio-mapper to">
              <i class="icon route-unloading"/>
            </div>
            <div v-else
                 class="radio-mapper">
              <i class="icon sort"></i>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
  export default {
    props: {
      value: {
        type: Object,
        default: () => {
          return {
            items: []
          }
        }
      }
    },
    components: {}
  }
</script>
<style scoped
       lang="scss">
  .ob-order-route-multicard {
    background-color: $background-white;

    .card-title {
      font-weight: bold;
      font-size: 20px;
      line-height: 28px;
    }

    .card-list {
      margin-left: 30px;
      margin-top: 15px;

      .card-list-item {
        padding: 15px 0 15px 0px;
        position: relative;

        &.done {
          &:before {
            content: '';
            position: absolute;
            display: block;
            top: 0px;
            left: -2px;
            width: 2px;
            height: 100%;
            background: $color-blue-navy-blue;
            z-index: 1;
          }

          .radio-mapper {
            border: 2px solid $color-blue-navy-blue;
          }
        }

        &.current {
          &:before {
            content: '';
            position: absolute;
            display: block;
            top: 0px;
            left: -2px;
            width: 2px;
            height: 50%;
            background: $color-blue-navy-blue;
            z-index: 1;
          }

          .radio-mapper {
            border: 2px solid $color-blue-navy-blue;
          }
        }

        &:first-child {
          &:after {
            content: '';
            position: absolute;
            display: block;
            top: 0px;
            left: -2px;
            width: 2px;
            height: 50%;
            background: $background-white;
            z-index: 2;
          }
        }

        &:last-child {
          &:after {
            content: '';
            position: absolute;
            display: block;
            bottom: 0px;
            left: -2px;
            width: 2px;
            height: 50%;
            background: $background-white;
            z-index: 2;
          }
        }

        .mapper-wrapper {
          position: absolute;
          width: 30px;
          height: 30px;
          top: 50%;
          transform: translateY(-50%);
          z-index: 3;

          .sort {
            color: $color-grey-border;
            font-size: 18px;
          }

          .dashed-line {
            position: absolute;
            width: 1px;
            left: 13px;
            height: 100px;
            top: 30px;
            border-left: 2px dashed $color-grey-border;

            &.none {
              display: none;
            }

            .dop-radio-mapper {
              position: absolute;
              border: 1px solid $color-grey-border;
              background-color: $background-white;
              border-radius: 50%;
              width: 30px;
              height: 30px;
              bottom: -25px;
              left: -15px;
              display: flex;
              align-items: center;
              justify-content: center;
            }
          }

          .top-icon {
            position: absolute;
            top: -30px;
            left: 50%;
            transform: translateX(-50%);

            .icon {
              font-size: 18px;
              color: #99B7E9;
            }
          }

          .radio-mapper {
            position: absolute;
            border: 1px solid $color-grey-border;
            background-color: $background-white;
            border-radius: 50%;
            width: 100%;
            height: 100%;
            top: 0;
            left: 0;
            display: flex;
            align-items: center;
            justify-content: center;

          }
        }

        .item-icon {
          background-repeat: no-repeat;
          background-size: contain;
          background-position: center;
          display: inline-block;
          vertical-align: middle;
        }

        .card-list-container {
          display: flex;
          padding: 15px;
          background: $background-white;
          box-shadow: 0px 2px 7px rgba($color-blue-navy-blue, 0.1);
          font-size: 12px;
          line-height: 18px;
          width: 284px;
          border: 1px solid $color-grey-border;

          .location-head {
            display: flex;
            font-size: 16px;
            line-height: 18px;
            letter-spacing: 0.2px;
            color: $color-text-base;
            margin-bottom: 6px;
            font-weight: normal;

            &__title {
              margin-top: 4px;
            }
          }

          .location-text {
            text-transform: uppercase;
            font-variant: small-caps;
            color: $color-grey-span;
            font-size: 10px;
            line-height: 16px;
            padding-left: 31px;
            height: 32px;
            letter-spacing: 0.2px;
          }

          .location-address {
            width: 292px;
            margin-right: 10px;

            .icon {
              color: $color-blue-navy-blue;
              font-size: 25px;
              margin-right: 6px;
              vertical-align: middle;
            }
          }

          &:after {
            content: '';
            position: absolute;
            width: calc(100% - 284px);
            left: 284px;
            top: 50%;
            height: 1px;
            background: $color-grey-border;
          }
        }

        &.history-log {
          .card-list-container {
            background: $light-lavender;
            padding: 3px 20px;
            letter-spacing: 0.4px;
            text-transform: uppercase;
            font-variant: small-caps;
            font-size: 12px;
            line-height: 18px;
            min-height: 40px;

            .history-log-time {
              color: $color-grey-span;
              float: left;
              width: 65px;
              line-height: 18px;
            }

            .history-log-message {
              color: $color-text-base;
              margin: 0 144px 0 65px;
              padding: 10px 20px 5px 50px;
            }

            .history-log-type {
              padding: 10px;
              color: $color-grey-span;
              float: right;
              width: 144px;
            }
          }
        }

        &.history-log + .history-log {
          padding-top: 0;
          margin-top: -10px;

          :not(.current) {
            .radio-mapper {
              display: none;
            }
          }
        }
      }
    }
  }
</style>
